Index: /trunk/src/lib/graphics/importer/texture.cc
===================================================================
--- /trunk/src/lib/graphics/importer/texture.cc	(revision 6870)
+++ /trunk/src/lib/graphics/importer/texture.cc	(revision 6871)
@@ -284,5 +284,5 @@
                GL_UNSIGNED_BYTE,
                surface->pixels);
-  printf("%s, w:%d h:%d, 0x%x\n", this->getName(), surface->w, surface->h, target);
+  //  printf("%s, w:%d h:%d, 0x%x\n", this->getName(), surface->w, surface->h, target);
 
   // build the MipMaps automaticaly
Index: /trunk/src/lib/sound/ogg_player.h
===================================================================
--- /trunk/src/lib/sound/ogg_player.h	(revision 6870)
+++ /trunk/src/lib/sound/ogg_player.h	(revision 6871)
@@ -20,39 +20,39 @@
 
 
-#define BUFFER_SIZE (4096 * 4)
+#define BUFFER_SIZE (8096 * 4)
 
 
 // the definition of a Ogg-Player
 class OggPlayer : public BaseObject
-  {
-  public:
-    OggPlayer(const char* fileName = NULL);
+{
+public:
+  OggPlayer(const char* fileName = NULL);
 
-    bool open(const char* fileName);
-    void release();
-    void debug();
-    bool playback();
-    bool playing();
-    bool update();
+  bool open(const char* fileName);
+  void release();
+  void debug();
+  bool playback();
+  bool playing();
+  bool update();
 
-  protected:
+protected:
 
-    bool stream(ALuint buffer);
-    void empty();
-    void check();
-    const char* errorString(int code);
+  bool stream(ALuint buffer);
+  void empty();
+  void check();
+  const char* errorString(int code);
 
-  private:
+private:
 
-    FILE*               oggFile;              //!< general file-handler, to open the sound-file
-    OggVorbis_File      oggStream;            //!< The stream this Ogg-player is playing back
-    vorbis_info*        vorbisInfo;           //!< The information held in the opened ogg-file
-    vorbis_comment*     vorbisComment;        //!< Comments about the ogg-file
+  FILE*               oggFile;              //!< general file-handler, to open the sound-file
+  OggVorbis_File      oggStream;            //!< The stream this Ogg-player is playing back
+  vorbis_info*        vorbisInfo;           //!< The information held in the opened ogg-file
+  vorbis_comment*     vorbisComment;        //!< Comments about the ogg-file
 
-    ALuint              buffers[2];           //!< buffers that handle sequentially buffering of the audio
-    ALuint              source;               //!< The source we play back on
-    ALenum              format;               //!< The format we play back
-    bool                trackLoaded;          //!< If a Track has been loaded.
-  };
+  ALuint              buffers[2];           //!< buffers that handle sequentially buffering of the audio
+  ALuint              source;               //!< The source we play back on
+  ALenum              format;               //!< The format we play back
+  bool                trackLoaded;          //!< If a Track has been loaded.
+};
 
 
Index: /trunk/src/world_entities/playable.cc
===================================================================
--- /trunk/src/world_entities/playable.cc	(revision 6870)
+++ /trunk/src/world_entities/playable.cc	(revision 6871)
@@ -253,11 +253,11 @@
 {
   SYNCHELP_READ_BEGIN();
-  
+
   byte flags;
-  
+
   SYNCHELP_READ_BYTE( flags, NWT_PL_FLAGS );
-  
+
   bFire = (flags & FLAGS_bFire) != 0;
-  
+
   return SYNCHELP_READ_N;
 }
@@ -267,13 +267,13 @@
   SYNCHELP_WRITE_BEGIN();
   byte flags = 0;
-  
+
   if ( bFire )
     flags |= FLAGS_bFire;
-  
+
 
   SYNCHELP_WRITE_BYTE( flags, NWT_PL_FLAGS );
   oldFlags = flags;
 
-  
+
   return SYNCHELP_WRITE_N;
 }
@@ -282,8 +282,8 @@
 {
   byte flags = 0;
-  
+
   if ( bFire )
     flags |= FLAGS_bFire;
-  
+
   return flags!=oldFlags;
 }
Index: /trunk/src/world_entities/playable.h
===================================================================
--- /trunk/src/world_entities/playable.h	(revision 6870)
+++ /trunk/src/world_entities/playable.h	(revision 6871)
@@ -27,6 +27,6 @@
     virtual ~Playable();
 
-    virtual void enter()=0;
-    virtual void leave()=0;
+    virtual void enter() = 0;
+    virtual void leave() = 0;
 
     virtual bool pickup(PowerUp* powerUp);
@@ -54,5 +54,5 @@
     /** @return a List of Events in PEV_* sytle */
     inline const std::list<int>& getEventList() { return this->events; };
-    
+
     int       writeSync(const byte* data, int length, int sender);
     int       readSync(byte* data, int maxLength );
Index: /trunk/src/world_entities/player.h
===================================================================
--- /trunk/src/world_entities/player.h	(revision 6870)
+++ /trunk/src/world_entities/player.h	(revision 6871)
@@ -30,7 +30,7 @@
     bool              setControllable(Playable* controllalble);
     inline Playable*  getControllable() { return this->controllable; };
+    bool              disconnectControllable();
 
     void              weaponConfigChanged();
-    bool              disconnectControllable();
 
     // eventListener extension.
Index: /trunk/src/world_entities/space_ships/helicopter.cc
===================================================================
--- /trunk/src/world_entities/space_ships/helicopter.cc	(revision 6870)
+++ /trunk/src/world_entities/space_ships/helicopter.cc	(revision 6871)
@@ -213,18 +213,9 @@
 }
 
-void  Helicopter::attachCamera()
-{
+void Helicopter::enter()
+{
+  dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( true);
   State::getCamera()->setParentSoft(this->getWeaponManager()->getFixedTarget());
   State::getCameraTarget()->setParentSoft(this->getWeaponManager()->getFixedTarget());
-
-}
-
-
-void Helicopter::enter()
-{
-  dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( true);
-  this->attachCamera();
-
-
 }
 
Index: /trunk/src/world_entities/space_ships/helicopter.h
===================================================================
--- /trunk/src/world_entities/space_ships/helicopter.h	(revision 6870)
+++ /trunk/src/world_entities/space_ships/helicopter.h	(revision 6871)
@@ -25,5 +25,4 @@
     virtual void enter();
     virtual void leave();
-    virtual void attachCamera();
 
     virtual void postSpawn();
Index: /trunk/src/world_entities/space_ships/hover.cc
===================================================================
--- /trunk/src/world_entities/space_ships/hover.cc	(revision 6870)
+++ /trunk/src/world_entities/space_ships/hover.cc	(revision 6871)
@@ -39,5 +39,7 @@
  */
 Hover::~Hover ()
-{}
+{
+
+}
 
 /**
@@ -185,18 +187,12 @@
 }
 
-void  Hover::attachCamera()
-{
+
+void Hover::enter()
+{
+  dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( true);
+
   State::getCamera()->setParentSoft(&this->cameraNode);
   State::getCamera()->setRelCoorSoft(-10, 0,0);
   State::getCameraTarget()->setParentSoft(&this->cameraNode);
-}
-
-
-void Hover::enter()
-{
-  dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( true);
-  this->attachCamera();
-
-
 }
 
Index: /trunk/src/world_entities/space_ships/hover.h
===================================================================
--- /trunk/src/world_entities/space_ships/hover.h	(revision 6870)
+++ /trunk/src/world_entities/space_ships/hover.h	(revision 6871)
@@ -22,5 +22,4 @@
     virtual void enter();
     virtual void leave();
-    virtual void attachCamera();
 
     virtual void postSpawn();