Index: trunk/src/lib/graphics/render2D/element_2d.cc
===================================================================
--- trunk/src/lib/graphics/render2D/element_2d.cc	(revision 6877)
+++ trunk/src/lib/graphics/render2D/element_2d.cc	(revision 6878)
@@ -148,14 +148,14 @@
 
 // PNode-style:
-  LoadParam(root, "rel-coor", this, Element2D, setRelCoor2D)
+  LoadParam(root, "rel-coor-2d", this, Element2D, setRelCoor2D)
       .describe("Sets The relative position of the Node to its parent.");
 
-  LoadParam(root, "abs-coor", this, Element2D, setAbsCoor2D)
+  LoadParam(root, "abs-coor-2d", this, Element2D, setAbsCoor2D)
       .describe("Sets The absolute Position of the Node.");
 
-  LoadParam(root, "rel-dir", this, Element2D, setRelDir2D)
+  LoadParam(root, "rel-dir-2d", this, Element2D, setRelDir2D)
       .describe("Sets The relative rotation of the Node to its parent.");
 
-  LoadParam(root, "abs-dir", this, Element2D, setAbsDir2D)
+  LoadParam(root, "abs-dir-2d", this, Element2D, setAbsDir2D)
       .describe("Sets The absolute rotation of the Node.");
 
Index: trunk/src/story_entities/game_world.cc
===================================================================
--- trunk/src/story_entities/game_world.cc	(revision 6877)
+++ trunk/src/story_entities/game_world.cc	(revision 6878)
@@ -115,6 +115,4 @@
       .describe("The Filename of this GameWorld (relative from the data-dir)");
 
-//   LoadParam(root, "soundtrack", this->dataTank, GameWorldData, setSoundTrack);
-
   PRINTF(4)("Loaded GameWorld specific stuff\n");
 }
Index: trunk/src/story_entities/simple_game_menu.cc
===================================================================
--- trunk/src/story_entities/simple_game_menu.cc	(revision 6877)
+++ trunk/src/story_entities/simple_game_menu.cc	(revision 6878)
@@ -64,4 +64,6 @@
 
   this->loadParams(root);
+
+  State::setMenuMode(true);
 }
 
@@ -166,8 +168,11 @@
     {
       this->menuSelector = dynamic_cast<ImageEntity*>(*entity);
+      this->menuSelector->setBindNode((const PNode*)NULL);
     }
     else if( !strcmp( "StartGame_Menu", (*entity)->getName()))
     {
       this->menuStartGame = dynamic_cast<ImageEntity*>(*entity);
+      this->menuStartGame->setBindNode((const PNode*)NULL);
+      this->menuStartGame->setRelCoor2D(State::getResX() / 2.0f, State::getResY() / 2.0f + (this->menuLayer[0]->menuList.size() * 50.0f), 0.0f);
       this->menuLayer[0]->menuList.push_back(dynamic_cast<ImageEntity*>(*entity));
 
@@ -176,4 +181,6 @@
     {
       this->menuStartMultiplayerGame = dynamic_cast<ImageEntity*>(*entity);
+      this->menuStartMultiplayerGame->setBindNode((const PNode*)NULL);
+      this->menuStartMultiplayerGame->setRelCoor2D(State::getResX() / 2.0f, State::getResY() / 2.0f + (this->menuLayer[0]->menuList.size() * 50.0f), 0.0f);
       this->menuLayer[0]->menuList.push_back(dynamic_cast<ImageEntity*>(*entity));
     }
@@ -181,10 +188,13 @@
     {
       this->menuQuitGame = dynamic_cast<ImageEntity*>(*entity);
+      this->menuQuitGame->setBindNode((const PNode*)NULL);
+      this->menuQuitGame->setRelCoor2D(State::getResX() / 2.0f, State::getResY() / 2.0f + (this->menuLayer[0]->menuList.size() * 50.0f), 0.0f);
       this->menuLayer[0]->menuList.push_back(dynamic_cast<ImageEntity*>(*entity));
     }
   }
+  this->menuSelected->getNullElement()->update2D(0.0f);
   this->menuSelectedIndex = 0;
   this->menuSelected = this->menuLayer[0]->menuList[this->menuSelectedIndex];
-  this->menuSelector->setAbsCoor(this->menuSelected->getAbsCoor());
+  this->menuSelector->setAbsCoor2D(this->menuSelected->getAbsCoor2D());
 
 
@@ -202,14 +212,17 @@
       ImageEntity* ie = new ImageEntity();
       ie->setTexture(se->getMenuItemImage());
-      ie->setRelCoor(0.0f,20.0f - (this->menuLayer[1]->menuList.size() * 10.0f), 0.0f);
       ie->setVisibility(false);
+      ie->setBindNode((const PNode*)NULL);
+      ie->setRelCoor2D(State::getResX() / 2.0f, State::getResY() / 2.0f + (this->menuLayer[1]->menuList.size() * 50.0f), 0.0f);
       this->menuLayer[1]->menuList.push_back(ie);
 
       // generating screenshoot item
-//       ie = new ImageEntity();
-//       ie->setTexture(se->getMenuScreenshoot);
-//       ie->setRelCoor(.0f, 10.0f, 0.0f);
-//       this->menuLayer[1]->screenshootList.push_back(ie);
-
+      ie = new ImageEntity();
+      ie->setTexture(se->getMenuScreenshoot());
+      //ie->setRelCoor(10.0f, 10.0f, 0.0f);
+      ie->setVisibility(false);
+      ie->setBindNode((const PNode*)NULL);
+      ie->setRelCoor2D(State::getResX() / 2.0f + 200.0f, State::getResY() / 2.0f, 0.0f);
+      this->menuLayer[1]->screenshootList.push_back(ie);
     }
   }
@@ -345,5 +358,5 @@
     {
       this->menuSelected = this->menuLayer[this->layerIndex]->menuList[++this->menuSelectedIndex];
-      this->menuSelector->setAbsCoor(this->menuSelected->getAbsCoor());
+      this->menuSelector->setAbsCoor2D(this->menuSelected->getAbsCoor2D());
     }
   }
@@ -353,5 +366,5 @@
     {
       this->menuSelected = this->menuLayer[this->layerIndex]->menuList[--this->menuSelectedIndex];
-      this->menuSelector->setAbsCoor(this->menuSelected->getAbsCoor());
+      this->menuSelector->setAbsCoor2D(this->menuSelected->getAbsCoor2D());
     }
   }
@@ -374,5 +387,10 @@
   std::vector<ImageEntity*>::iterator it;
   // fade old menu
-  for( it = this->menuLayer[layer1]->menuList.begin(); it != this->menuLayer[layer1]->menuList.end(); it++ )
+  for( it = this->menuLayer[layer1]->menuList.begin(); it != this->menuLayer[layer1]->menuList.end(); it++)
+  {
+    (*it)->setVisibility(false);
+  }
+  //also fade the screenshots if in level choosement mode
+  for( it = this->menuLayer[layer1]->screenshootList.begin(); it != this->menuLayer[layer1]->screenshootList.end(); it++)
   {
     (*it)->setVisibility(false);
@@ -386,8 +404,14 @@
     (*it)->setVisibility(true);
   }
+    //also fade the screenshots if in level choosement mode
+  for( it = this->menuLayer[layer1]->screenshootList.begin(); it != this->menuLayer[layer1]->screenshootList.end(); it++)
+  {
+    (*it)->setVisibility(true);
+  }
+
 
   this->layerIndex = layer2;
   this->menuSelected = this->menuLayer[layer2]->menuList[0];
-  this->menuSelector->setAbsCoor(this->menuSelected->getAbsCoor());
+  this->menuSelector->setAbsCoor2D(this->menuSelected->getAbsCoor2D());
   this->menuSelectedIndex = 0;
 }
Index: trunk/src/story_entities/story_entity.cc
===================================================================
--- trunk/src/story_entities/story_entity.cc	(revision 6877)
+++ trunk/src/story_entities/story_entity.cc	(revision 6878)
@@ -42,4 +42,5 @@
   this->description = NULL;
   this->menuItemImage = NULL;
+  this->menuScreenshoot = NULL;
   this->nextStoryID = WORLD_ID_GAMEEND;
   this->bMenuEntry = false;
@@ -77,5 +78,5 @@
       .describe("If this entry is 1, the world is contained in the SimpleGameMenu");
 
-  LoadParam(root, "menu-screenshoot", this, StoryEntity, setMenuScreenshoot)
+  LoadParam(root, "screenshoot", this, StoryEntity, setMenuScreenshoot)
       .describe("If this entry is 1, the world is contained in the SimpleGameMenu");
 