Index: code/branches/fps/data/levels/presentation_FS10.oxw
===================================================================
--- code/branches/fps/data/levels/presentation_FS10.oxw	(revision 6883)
+++ code/branches/fps/data/levels/presentation_FS10.oxw	(revision 6883)
@@ -0,0 +1,95 @@
+<?lua
+  include("hudtemplates3.oxo")
+  include("stats.oxo")
+  include("templates/spaceship_assff.oxt")
+  include("templates/spaceship_H2.oxt")
+  include("templates/fps.oxt")
+?>
+
+<Level
+ name         = "fps"
+ description  = "tests"
+>
+  <Scene
+   ambientlight = "0.1, 0.1, 0.1"
+   skybox       = "Orxonox/skypanoramagen1"
+   gravity      = "0,-1000,0"
+   negativeWorldRange = "(-100000, -100000, -100000)"
+   positiveWorldRange = "( 100000,  100000,  100000)"
+   hasPhysics   = true
+  >
+    <Light type=directional position="0,-100000,0" direction="0.02, -1, 0.05" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
+
+  <StaticEntity position="0,-50,0" direction="0,-1,0" collisionType=static mass=100000 >
+      <attached>
+        <Model position="0,0,0" mesh="cube.mesh" scale3D="100,100,10" />
+      </attached>
+      <collisionShapes>
+        <BoxCollisionShape position="0,0,0" halfExtents="100,100,10" />
+      </collisionShapes>
+  </StaticEntity>
+
+   <StaticEntity position="210,-30,0" direction="0,-1,0" collisionType=static mass=100000 >
+      <attached>
+        <Model position="0,0,0" mesh="cube_orange.mesh" scale3D="100,100,10" />
+      </attached>
+      <collisionShapes>
+        <BoxCollisionShape position="0,0,0" halfExtents="100,100,10" />
+      </collisionShapes>
+  </StaticEntity>
+  
+   <StaticEntity position="600,-20,0" direction="0,-1,0" collisionType=static mass=100000 >
+      <attached>
+        <Model position="0,0,0" mesh="cube_green.mesh" scale3D="100,100,10" />
+      </attached>
+      <collisionShapes>
+        <BoxCollisionShape position="0,0,0" halfExtents="100,100,10" />
+      </collisionShapes>
+  </StaticEntity>
+
+<StaticEntity position="600,10,120" direction="0,-1,1" collisionType=static mass=100000 >
+      <attached>
+        <Model position="0,0,0" mesh="cube_red.mesh" scale3D="100,100,10" />
+      </attached>
+      <collisionShapes>
+        <BoxCollisionShape position="0,0,0" halfExtents="100,100,10" />
+      </collisionShapes>
+  </StaticEntity>
+  
+  <StaticEntity position="600,40,250" direction="0,-1,0" collisionType=static mass=100000 >
+      <attached>
+        <Model position="0,0,0" mesh="cube.mesh" scale3D="100,100,10" />
+      </attached>
+      <collisionShapes>
+        <BoxCollisionShape position="0,0,0" halfExtents="100,100,10" />
+      </collisionShapes>
+  </StaticEntity>
+<?lua
+for i = 1, 10, 1
+do ?>
+    <SpawnPoint position="0,300,0" direction="0, 0, 0" lookat="0,0,100000000" spawnclass=FpsPlayer pawndesign=fps />
+<?lua
+end
+?>
+
+<!--
+<?lua
+for i = 1, 200, 1
+do
+j = math.random()
+?>
+
+    <MovableEntity position="<?lua print(math.random() * 5000-2000) ?>,<?lua print(math.random() * 5000-2000) ?>,<?lua print(math.random() * 5000 - 2000) ?>" collisionType=dynamic linearDamping=0.8 angularDamping=0 mass=<?lua print(j * 100) ?> scale=<?lua print(j * 5) ?> rotationaxis="<?lua print(math.random()) ?>, <?lua print(math.random()) ?>, <?lua print(math.random()) ?>" rotationrate="<?lua print(math.random() * 30 + 5) ?>" >
+      <attached>
+        <Model position="0,0,0" scale=<?lua print(j * 10) ?> mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh" />
+      </attached>
+      <collisionShapes>
+        <SphereCollisionShape radius="<?lua print(j * 100) ?>" />
+      </collisionShapes>
+    </MovableEntity>
+<?lua
+end
+?>
+-->
+  </Scene>
+</Level>
Index: code/branches/fps/data/levels/templates/fps.oxt
===================================================================
--- code/branches/fps/data/levels/templates/fps.oxt	(revision 6882)
+++ code/branches/fps/data/levels/templates/fps.oxt	(revision 6883)
@@ -1,5 +1,5 @@
 <Template name=fps>
   <FpsPlayer
-   hudtemplate            = spaceshiphud
+   hudtemplate            = fpshud
    camerapositiontemplate = fpscamera
  
@@ -29,5 +29,5 @@
 -->
     <collisionShapes>
-      <BoxCollisionShape position="0,0,0" halfExtents="100,10,100" />
+      <BoxCollisionShape position="0,0,0" halfExtents="7,7,7" />
     <!--
       <SphereCollisionShape radius="10" />
Index: code/branches/fps/data/overlays/hudtamplates_fps.oxo
===================================================================
--- code/branches/fps/data/overlays/hudtamplates_fps.oxo	(revision 6882)
+++ code/branches/fps/data/overlays/hudtamplates_fps.oxo	(revision 6883)
@@ -4,6 +4,6 @@
 </Template>
 
-<Template name="spaceshiphud">
-  <OverlayGroup name = "spaceshiphud" scale = "1, 1">
+<Template name="fpshud">
+  <OverlayGroup name = "fpshud" scale = "1, 1">
     <Map />
 
@@ -73,10 +73,10 @@
     />
 
-    <GUIOverlay
+ <!--   <GUIOverlay
       name = "QuestGUI"
       guiname = "QuestGUI"
       visible = "false"
     />
-
+-->
   </OverlayGroup>
 </Template>